

import com.sun.xml.internal.ws.policy.privateutil.PolicyUtils;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.*;
public class App {
    public static final int EM_MAXSTEPS = 1000000;
    public static final double EM_ACC = 1e-4;
    public static final int BP_MAXSTEPS = 100;
    public static final double BP_ACC = 1e-3;
    public static final int CHECKINT = 100;
    public static final double ALPHA_ACC = 1e-3;

    public static final int M =4;
    public static final int N =20;
    public static double beta = 1;

    public static final Gaosi20 gs = new Gaosi20();

    public static Network G;
    public static int twom;
    public static double twos;
    public static double[][] c = new double[M+1][M+1];
    public static double[][][] eta;
    public static double[][] q;
    public static int[] binom = new int[M+1];
    public static double[][] bernst = new double[M+1][N];

    public static final Crnd rnd = new Crnd();

    public static void main(String[] args) throws IOException {

//        String[] array1 = {"1000d2","1000d22","1000d32","1000d3","1000d4","1000d5", "1000d6", "1000d9","1000d12","1000d15"};
//        String[] array2 = {"rand", "new","one","onerand","randone"};
        String[] array1 = {"1000d23"};
        String[] array2 = {"rand", "one","onerand","randone"};

        // Traversing two string arrays
        for (String strr1 : array1) {


                //Reading a network in dat format
                File file1 = new File(".\\Debug\\"+strr1+"\\community.dat");
                File file2 = new File(".\\Debug\\"+strr1+"\\network.dat");
                Readdat readdat = new Readdat();
                String str1 = readdat.Read_file_com(file1);
                String str2 = readdat.Read_file_net(file2);
                G = readdat.create_network(str1,str2);
                int u=0;
                int d2_node_num = 0;
                for (u = twom = 0, twos = 0.0; u < G.getNvertices(); u++) {
                    if (G.getVertex().get(u).getDegree() == 2) {
                        d2_node_num += 1;
                    }
                    twom += G.getVertex().get(u).getDegree();
                    twos += G.getVertex().get(u).getSwt();
                }
                double aver_d = (double) twom / G.getNvertices();
                double density = aver_d / (G.getNvertices() - 1);
                double d2_prop = (double) d2_node_num / G.getNvertices() * 100;
                System.out.println("The network contains " + G.getNvertices() + "nodes, " + twom / 2 + "edges.The average degree is " + aver_d + ". The total weight is " + twos / 2 + ". The proportion of nodes with a degree of 2 is " + d2_prop + ". The density is " + density);

                for (String strr2 : array2) {
                    FileOutputStream out=new FileOutputStream("E:\\JavaProjects\\FusionAlgorithms\\aaa2.txt",true);
                    String res = strr1+"---"+strr2;
                    out.write(res.getBytes());
                    out.close();
                    detection(aver_d,strr2 );

            }
        }

    }
    private static void detection(double aver_d,String strr2) throws IOException {
        int u, v, i, j, k, r;
        int steps;
        double deltac, maxdelta, norm;
        double[][] oldc = new double[M + 1][M + 1];

        binoms();//Calculate polynomial combination coefficients
        bernstein();//Calculate the values of Bernstein polynomials at the integration points.
        FileOutputStream out=new FileOutputStream("E:\\JavaProjects\\FusionAlgorithms\\aaa2.txt",true);

        long start = System.currentTimeMillis();

        //Initialize the messages
        q = new double[G.getNvertices()][N];
        for(u=0;u<G.getNvertices();u++){
            for(r=0,norm = 0.0;r<N;r++){
                q[u][r] = (double)(u+r)%100/100;
                norm += gs.gw[r]*q[u][r];
            }
            for(r=0;r<N;r++){
                q[u][r] /= norm;
            }
        }

        eta = new double[G.getNvertices()][][];
        for(u=0;u<G.getNvertices();u++){
            eta[u] = new double[G.getVertex().get(u).getDegree()][N];
            for(i=0;i<G.getVertex().get(u).getDegree();i++){
                v = G.getVertex().get(u).getEdge().get(i).getTarget();
                for(r=0;r<N;r++){
                    eta[u][i][r] = q[v][r];
                }
            }
        }
        if(strr2.equals("rand")){
//            System.out.println("The initialization value of the combination coefficient is ");
            for(j=0;j<=M;j++){
//                System.out.print("{");
                for(k=0;k<=M;k++){
//                    if(j==k){
//                        c[j][k] = Math.random();
//                    }else if(j<k){
//                        c[j][k] = Math.random();
//                    }else{
//                        c[j][k] = c[k][j];
//                    }
//                    System.out.print(c[j][k]+",");
                    c[j][k] = rnd.crnd[j][k];
                }
//                System.out.println("},");
            }
        }
        if(strr2.equals("new")){
            System.out.println("The initialization value of the combination coefficient is ");
            for(j=0;j<=M;j++){
                System.out.print("{");
                for(k=0;k<=M;k++){
                    if(j==k){
                        c[j][k] = aver_d%10+1;
                    }else if(j-k<0){
                        c[j][k] = Math.exp(j-k);
                    }else{
                        c[j][k] = c[k][j];
                    }
                    System.out.print(c[j][k]+",");
                    //c[j][k] = rnd.crnd[j][k];
                }
                System.out.println("},");
            }
        }
        if(strr2.equals("one")){
            for(j=0;j<=M;j++){
                for(k=0;k<=M;k++){
                    c[j][k] = 1.0;
                }
            }
        }
        if(strr2.equals("onerand")){
            for(j=0;j<=M;j++){
                for(k=0;k<=M;k++){
                    if(j==k){
                        c[j][k] = 1;
                    }else if(j<k){
                        c[j][k] = Math.random();
                    }else{
                       c[j][k] = c[k][j];
                    }
                }
            }
        }
        if(strr2.equals("randone")){
            for(j=0;j<=M;j++){
                for(k=0;k<=M;k++){
                    if(j==k){
                        c[j][k] = Math.random();
                    }else if(j<k){
                        c[j][k] = 1.0;
                    }else{
                        c[j][k] = c[k][j];
                    }
                }
            }
        }

        //Expectation Maximization algorithm starts.
        System.out.println("Expectation Maximization algorithm starts.");
        steps = 0;
        do {
            //Belief Propagation algorithm starts.
            bp();
            //Store the current model parameters.
            for(j=0; j<=M; j++){
                for(k=0;k<=M;k++){
                    oldc[j][k] = c[j][k];
                }
            }

            //Calculate the new parameters.
            params();

            maxdelta = 0.0;
            for(j=0;j<=M;j++){
                for(k=0;k<=M;k++){
                    deltac = Math.abs(c[j][k]-oldc[j][k]);
                    if(deltac>maxdelta){
                        maxdelta = deltac;
                    }
                }
            }
        } while((maxdelta>EM_ACC)&&(++steps<=EM_MAXSTEPS));

        System.out.println("The configured combination coefficient is ");
        for(j=0;j<=M;j++){
            System.out.print("{");
            for(k=0;k<=M;k++){
                System.out.print(c[j][k]+",");
            }
            System.out.println("},");
        }

        long end = System.currentTimeMillis();
        System.out.println("Time: "+(end-start));
        System.out.println("Error: "+maxdelta);
        System.out.println("Number of iterations: "+steps);
        //Output the q[r]
        //System.out.println("xi[i]=");
        double aver=0;
        double[] xi = new double[G.getNvertices()];
        for(i=0;i<G.getNvertices();i++){
            for(r=0;r<N;r++){
                xi[i] += gs.gw[r]*gs.gx[r]*q[i][r];
            }
            //System.out.println(xi[i]+",");
            aver += xi[i];
        }
        aver /= xi.length;
        double stan = 0;
        for(int i1=0;i1< xi.length;i1++){
            stan += (xi[i1]-aver)*(xi[i1]-aver);
        }
        stan = Math.sqrt(stan/ xi.length);
        System.out.println("Mean: "+aver);
        System.out.println("Standard deviation: "+stan);
        String res = "time:"+(end-start)+"---"+"std:"+stan+"\n";
        out.write(res.getBytes());
        out.close();
    }


        /**
         * Calculate polynomial combination coefficients.
         */
        public static void binoms() {
            int b, k;
            b = M;
            for (k = 1; k < M; k++) {
                b /= k;
                binom[k] = b;
                b *= M - k;
            }
            binom[0] = binom[M] = 1;
        }

        /**
         * Calculate the values of Bernstein polynomials at the integration points.
         */
        public static void bernstein() {
            int k, r;
            double x;
            for (k = 0; k <= M; k++) {
                for (r = 0; r < N; r++) {
                    x = gs.gx[r];  //Gaussian integration points.
                    bernst[k][r] = binom[k] * Math.pow(x, beta * k) * Math.pow(1 - Math.pow(x, beta), M - k);
                }
            }
        }

    public static void params(){
        int v;
        int i,j,k;
        int r,s;
        double norm;
        double newc,deltac,maxdelta;
        double[] nu = new double[N];
        double[][] mu = new double[N][N];
        double[][][][] Q = new double[M+1][M+1][N][N];
        double[][] W = new double[N][N];
        double[][] term = new double[N][N];
        double[] nuB = new double[M+1];
        //System.out.println("Calculate the model parameters.");

        for(r=0;r<N;r++){
            nu[r] = 0.0;
            for(i=0;i<G.getNvertices();i++){
                nu[r] += q[i][r]*G.getVertex().get(i).getSwt();
            }
            nu[r] /= twos;
        }

        for(j=0;j<=M;j++){
            nuB[j] = 0.0;
            for(r=0;r<N;r++){
                nuB[j] += gs.gw[r]*nu[r]*bernst[j][r];
            }
        }
        for (r=0; r<N; r++) {
            for (s=0; s<N; s++) {
                W[r][s] = 0.0;
                for (j=0; j<=M; j++) {
                    for (k=0; k<=M; k++) {
                        W[r][s] += c[j][k]*bernst[j][r]*bernst[k][s];
                    }
                }
            }
        }
        //Calculate the marginal probability of a pair of nodes.
        for(i=0;i<G.getNvertices();i++){
            for(j=0;j<G.getVertex().get(i).getDegree();j++){
                v = G.getVertex().get(i).getEdge().get(j).getTarget();
                for(k=0;k<G.getVertex().get(v).getDegree();k++){
                    if(G.getVertex().get(v).getEdge().get(k).getTarget() == i){
                        break;
                    }
                }
                if(k==G.getVertex().get(v).getDegree()){
                    System.out.println("出错了！");
                    return;
                }

                //Calculate the numerator and the normalization factor.
                norm = 0.0;
                for(r=0;r<N;r++){
                    for(s=0;s<N;s++){
                        term[r][s] = eta[i][j][r]*eta[v][k][s]*W[r][s];
                        norm += gs.gw[r]*gs.gw[s]*term[r][s];
                    }
                }
                //Calculate the u(x,y)
                for(r=0;r<N;r++){
                    for(s=0;s<N;s++){
                        mu[r][s] += G.getVertex().get(v).getEdge().get(k).getWeight()*term[r][s]/(twos*norm);
                    }
                }
            }
        }
        //Calculate the new parameters.
        do {
            //Calculate the Q
            for(r=0;r<N;r++){
                for(s=0;s<N;s++){
                    norm = 0.0;
                    for(j=0;j<=M;j++){
                        for(k=0;k<=M;k++){
                            Q[j][k][r][s] = c[j][k]*bernst[j][r]*bernst[k][s];
                            norm += Q[j][k][r][s];
                        }
                    }
                    for(j=0;j<=M;j++){
                        for(k=0;k<=M;k++){
                            Q[j][k][r][s] /= norm;
                        }
                    }
                }
            }
            maxdelta = 0.0;
            for(j=0;j<=M;j++){
                for(k=0;k<=M;k++){
                    newc = 0.0;
                    for(r=0;r<N;r++){
                        for(s=0;s<N;s++){
                            newc += gs.gw[r]*gs.gw[s]*mu[r][s]*Q[j][k][r][s];
                        }
                    }
                    newc /= nuB[j]*nuB[k];
                    deltac = Math.abs(c[j][k]-newc);
                    if(deltac>maxdelta){
                        maxdelta = deltac;
                    }
                    c[j][k] = newc;
                }
            }
        }while(maxdelta>ALPHA_ACC);
    }
    public static void bp(){
        int i,j,k;
        int u,v;
        int r,s;
        int stepsbp;
        double intsum;
        double deltaeta,maxdelta;
        double logeta,neweta,norm,largest=0.0;
        double[] nu = new double[N];
        double[] logpre = new double[N];
        double[] logqun = new double[N];
        double[][][] logetaun = new double[G.getNvertices()][][];;
        double[][] W = new double[N][N];
        for (r=0; r<N; r++) {
            for (s=0; s<N; s++) {
                W[r][s] = 0.0;
                for (j=0; j<=M; j++) {
                    for (k=0; k<=M; k++) {
                        W[r][s] += c[j][k]*bernst[j][r]*bernst[k][s];
                    }
                }
            }
        }
        //Initialize new messages.
        for(u=0;u<G.getNvertices();u++){
            logetaun[u] = new double[G.getVertex().get(u).getDegree()][N];
        }
        stepsbp = 0;
        do {
            for(r=0;r<N;r++){
                nu[r] = 0.0;
                for(i=0;i<G.getNvertices();i++){
                    nu[r] += q[i][r]*G.getVertex().get(i).getSwt();
                }
                nu[r] /= twos;
            }
            for(r=0;r<N;r++){
                logpre[r] = 0.0;
                for(s=0;s<N;s++){
                    logpre[r] += gs.gw[s]*nu[s]*W[r][s];
                }
            }
            for(i=0;i<G.getNvertices();i++){
                for(r=0;r<N;r++){
                    logqun[r] = -G.getVertex().get(i).getSwt()*logpre[r];
                    for(k=0;k<G.getVertex().get(i).getDegree();k++){
                        intsum = 0.0;
                        for(s=0;s<N;s++){
                            intsum += gs.gw[s]*eta[i][k][s]*W[r][s];
                        }
                        logqun[r] += Math.log(intsum);
                    }
                    if(r==0){
                        largest = logqun[r];
                    }else if(logqun[r]>largest){
                        largest = logqun[r];
                    }
                }
                //Regularize the (zi)
                norm = 0.0;
                for(r=0;r<N;r++){
                    logqun[r] -= largest;
                    norm += gs.gw[r]*Math.exp(logqun[r]);
                }
                for(r=0;r<N;r++){
                    q[i][r] = Math.exp(logqun[r])/norm;
                }
            }
            for(i=0;i<G.getNvertices();i++){
                for(j=0;j<G.getVertex().get(i).getDegree();j++){
                    v = G.getVertex().get(i).getEdge().get(j).getTarget();
                    for(r=0;r<N;r++){
                        logeta = -G.getVertex().get(v).getSwt()*logpre[r];
                        for(k=0;k<G.getVertex().get(v).getDegree();k++){
                            if(G.getVertex().get(v).getEdge().get(k).getTarget()!=i){
                                intsum = 0.0;
                                for(s=0;s<N;s++){
                                    intsum += gs.gw[s]*eta[v][k][s]*W[r][s];
                                }
                                logeta += Math.log(intsum);
                            }else{
                                logeta += Math.log(G.getVertex().get(v).getEdge().get(k).getWeight());
                            }
                        }
                        logetaun[i][j][r] = logeta;
                    }
                }
            }
            //Regularize and calculate the maximum change.
            maxdelta = 0.0;
            for(i=0;i<G.getNvertices();i++){
                for(k=0;k<G.getVertex().get(i).getDegree();k++){
                    norm = 0.0;
                    largest = logetaun[i][k][0];
                    for(r=1;r<N;r++){
                        if(logetaun[i][k][r]>largest){
                            largest = logetaun[i][k][r];
                        }
                    }
                    for(r=0;r<N;r++){
                        logetaun[i][k][r] -= largest;
                        norm += gs.gw[r]*Math.exp(logetaun[i][k][r]);
                    }
                    for(r=0;r<N;r++){
                        neweta = Math.exp(logetaun[i][k][r])/norm;
                        deltaeta = Math.abs(neweta-eta[i][k][r]);
                        if(deltaeta>maxdelta){
                            maxdelta = deltaeta;
                        }
                        eta[i][k][r] = neweta;
                    }

                }
            }
            ++stepsbp;
        }while((maxdelta>BP_ACC) && (stepsbp<=BP_MAXSTEPS));
    }


}