import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;


public class Readdat {
	
	public Network create_network(String str1,String str2){
		Network network = new Network();
		network.setDirected(0);		
		String nodes = str1.substring(0,str1.length()-1);
		String edges = str2.substring(0,str2.length()-1);
		String[] nodes1 = nodes.split(";");
		String[] edges1 = edges.split(";");
		
		network.setNvertices(nodes1.length);	
		ArrayList<Vertex> list = new ArrayList<Vertex>();
		for(int i=0;i<nodes1.length;i++){
			Vertex vertex = new Vertex();
			String node = nodes1[i];
			String[] arr = node.split(",");
			String id = arr[0];
			String label = arr[1];
			vertex.setId(Integer.parseInt(id)-1);
			vertex.setLabel(label);
						
			ArrayList<Edge> li = new ArrayList<Edge>();
			double swt = 0.0;
			for(int j=0;j<edges1.length;j++){
				String eg = edges1[j];
				String[] tmp = eg.split(",");
				String source = tmp[0];
				String target = tmp[1];
				String weight = tmp[2];
				int sc = Integer.parseInt(source)-1;
				int tg = Integer.parseInt(target)-1;
				double wt = Double.parseDouble(weight);
				if(vertex.getId()==sc){
					Edge edge = new Edge();
					edge.setTarget(tg);
					wt = Math.tanh(0.1*wt);//change weight to [0,1] (Optional)
					edge.setWeight(wt);
					li.add(edge);
					swt += wt;
				}
			}
			vertex.setEdge(li);
			vertex.setDegree(li.size());
			vertex.setSwt(swt);
			list.add(vertex);
		}
		network.setVertex(list);
		return network;
	}
	
	//Read the community.dat. Convert the file to a string. Format: 1,1;2,1 2;
	@SuppressWarnings("resource")
	public String Read_file_com(File file) throws IOException{
		if(!file.exists()||file.isDirectory()){
			throw new FileNotFoundException();
		}
		BufferedReader br=new BufferedReader(new FileReader(file));
		String temp=null;
		StringBuffer sb=new StringBuffer();
		temp=br.readLine();
		while(temp!=null){
			String[] arr = temp.split("\t");
			sb.append(arr[0]+","+arr[1].trim()+";");
			temp=br.readLine();
		}
		return sb.toString();
	}
	
	//Read the network.dat. Convert the file to a string. Format: 1,4,1.024;1,6,0.035;
	@SuppressWarnings("resource")
	public String Read_file_net(File file) throws IOException{
		if(!file.exists()||file.isDirectory()){
			throw new FileNotFoundException();
		}
		BufferedReader br=new BufferedReader(new FileReader(file));
		String temp=null;
		StringBuffer sb=new StringBuffer();
		temp=br.readLine();
		while(temp!=null){
			String[] arr = temp.split("\t");
			sb.append(arr[0]+","+arr[1]+","+10+";");
			temp=br.readLine();
		}
		return sb.toString();
	}
}
